#include "grade.h"

void* gcalloc(size_t n, size_t sizeof_something)
{
   void*   p;

   if ((p = calloc(n, sizeof_something)) == NULL) {
      fprintf(stderr, "\n%s\n%s%d%s%d\n\n",
	 "ERROR: calloc(n, sizeof_something) has failed",
	 "with n = ", n, " and sizeof_something = ", sizeof_something);
      exit(1);
   }
   return p;
}

void gfclose(FILE* fp)
{
   if (fclose(fp) == -1) {
      fprintf(stderr, "\nERROR:  fclose() failed - bye.\n\n");
      exit(1);
   }
}

FILE* gfopen(cchr* filename, cchr* mode)
{
   FILE*   fp;

   if ((fp = fopen(filename, mode)) == NULL) {
      fprintf(stderr, "WHOOPS: Cannot open %s!\n\n", filename);
   }
   return fp;
}

void gfseek(FILE* fp, long offset, int place)
{
   if (fseek(fp, offset, place) == -1) {
      fprintf(stderr, "\nCall to fseek() failed - bye.\n\n");
      exit(1);
   }
}

void ggetcwd(char *cwd, size_t sz)
{
   if (getcwd(cwd, sz) == NULL) {
      fprintf(stderr, "ERROR: getcwd() failed - bye!\n\n");
      exit(1);
   }
}

char* ggetenv(cchr* name)
{
   char*   p;

   if ((p = getenv(name)) == NULL) {
      fprintf(stderr, "\n%s%s%s\n\n",
	 "SORRY: Environment variable ", name, " not set - bye!");
      exit(1);
   }
   return p;
}

void* gmalloc(size_t sizeof_something)
{
   void*   p;

   if ((p = malloc(sizeof_something)) == NULL) {
      fprintf(stderr, "\nERROR:  malloc() failed - bye.\n\n");
      exit(1);
   }
   return p;
}

void gremove(cchr* fname)
{
   if (remove(fname) == -1) {
      fprintf(stderr, "\nERROR:  remove() failed - bye.\n\n");
      exit(1);
   }
}

void grename(cchr* from, cchr* to)
{
   if (rename(from, to) != 0) {
      fprintf(stderr, "\nERROR:  rename() failed - bye.\n\n");
      exit(1);
   }
}

void grewind(istream& is)
{
   is.clear();
   is.seekg(ios::beg);
   if (!is) {
      cout << "---\n"
	      "ERROR: Call to grewind() failed - bye!\n"
	      "\n";
      exit(1);
   }
}

void gsystem(cchr* s)
{
   if (system(s) == -1) {
      fprintf(stderr, "ERROR: Call to system() failed - bye!\n\n");
      exit(1);
   }
}
