#include <assert.h>
#include <ctype.h>
#include <fstream.h>
#include <iomanip.h>
#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strstream.h>
#include <unistd.h>
#include <sys/wait.h>                                  // for WIFEXITED()

class options;

// ---
// Using a macro is not a good idea,
// but this code is very old, and
// at the time I did not know
// any better.
//

#define   SET(p)   {                        \
   while (*(p) != '\0' && !isspace(*(p)))   \
      ++(p);                                \
   while (isspace(*(p)))                    \
      ++(p);                                \
}

enum no_yes {no, yes};
enum off_on {off, on};

typedef   const char   cchr;
typedef   const int    cint;
typedef   double       dbl;

cint   maxline   = 700;
cint   maxstring = 100;
cint   maxword   = 100;
cint   mnbsbt    = 3;       // minimum number of blank spaces before tags
cint   mnbsbs    = 2;     // minimum number of blank spaces before scores
cint   nbsbc     = 5;                     // blank spaces before comments

// ---
// The following values must be coordinated
// with what gets printed in get_option().
//

cint   Instructions          = 0;
cint   Enter_scores_or_lines = 1;
cint   Compute_total_scores  = 2;
cint   Assign_grades         = 3;
cint   Compute_statistics    = 4;
cint   Pretty_print          = 5;
cint   Print_on_paper        = 6;
cint   Publish_for_students  = 7;
cint   Reorder_the_database  = 8;
cint   View                  = 9;
cint   Quit                  = 10;        // Quit = highest option number

extern options   o;                                 // options are global

class options {
public:
            options();
   int      get_fwai() { return fwai; }
   int      get_nwacl() { return nwacl; }
   void     get_options(int argc, char** argv);
   cchr*    local_pgm_name() { return local_pgm_nm; }
   cchr*    pgm_name() { return pgm_nm; }
   off_on   help_option() { return help_opt; }
   off_on   help_help_option() { return help_help_opt; }
   off_on   help_help_help_option() { return help_help_help_opt; }
   off_on   test_option() { return test_opt; }

private:
   char*    local_pgm_nm;
   cchr*    pgm_nm;
   int      o_cnt;
   int      fwai;                              // first working arg index
   int      nwacl;                      // # of working args on cmnd line
   off_on   help_opt;
   off_on   help_help_opt;
   off_on   help_help_help_opt;
   off_on   test_opt;

   void     get_local_pgm_nm();
};

struct s_line;
struct s_nail;
struct s_tag;

typedef   struct s_line   LINE;
typedef   struct s_line   INFO_LINE;
typedef   struct s_line   SCORE_LINE;
typedef   struct s_nail   NAIL;
typedef   struct s_tag    TAG;

struct s_line {
   char    line[maxline];
   LINE*   next;
};

// ---
// NAIL := name and info lines
//

struct s_nail {
   char*    name_line;
   char**   info_line;
   dbl      score;      // a particular score from one of the score lines
};

struct s_tag {
   char*   tag;
   int     cnt_scores;
   TAG*    next;
};

// ---
// Because the header file containing the function declarations
// makes use of the above templates, it gets included last.
//

#include "f_decls.h"
