#include "grade.h"

options::options()
{
   local_pgm_nm = NULL;
   pgm_nm = NULL;
   o_cnt = 0;
   fwai = -1;                                  // first working arg index
   nwacl = -1;                          // # of working args on cmnd line
   help_opt = off;
   help_help_opt = off;
   help_help_help_opt = off;
   test_opt = off;
}

// ---
// If pgm_nm has a / in it, as in the following example,
// pick of the name following the last slash character.
//
//    /export/local/bin/ad
//

void options::get_local_pgm_nm()
{
   cchr*   p;
 
   p = pgm_nm + strlen(pgm_nm);
   for ( --p; p > pgm_nm && *p != '/'; --p)
      ;
   if (*p == '/')
      ++p;
   local_pgm_nm = new char [strlen(p) + 1];
   strcpy(local_pgm_nm, p);
}

void options::get_options(int argc, char** argv)
{
   cchr*   p;
   int     i;

   pgm_nm = argv[0];
   get_local_pgm_nm();
   for (i = 1; i < argc && *argv[i] == '-'; ++i) {
      for (p = argv[i] + 1; *p != '\0'; ++p) {
         switch (*p) {
         case 'h':
	    //
	    // Three possibilities:
	    //
	    //    -h     -hh     -hhh
	    //
	    if (strncmp(p, "hhh", 3) == 0) {
	       help_help_help_opt = on;
	       p += 2;                           // p points at last char
	    }
	    else if (strncmp(p, "hh", 2) == 0) {
	       help_help_opt = on;
	       p += 1;                           // p points at last char
	    }
	    else
	       help_opt = on;
            ++o_cnt;
            break;
         case 't':
            test_opt = on;
            ++o_cnt;
            break;
         default:
	    cout << "---\n"
		    "ERROR: Unknown option - bye!\n\n";
	    wrt_help(local_pgm_nm);
	    exit(1);
         }
      }
   }
   //
   // Capture the first working arg index.
   //
   fwai = i;
   nwacl = argc - fwai;
   if (test_opt == on) {
      off_on&   hlp = help_opt;
      off_on&   hhp = help_help_opt;
      off_on&   hhh = help_help_help_opt;
      off_on&   tst = test_opt;
      cout << "---\n"
              "TEST OPTION:\n"
              "\n"
              "         local_pgm_nm = " << local_pgm_nm << "\n"
              "               pgm_nm = " << pgm_nm << "\n"
              "                o_cnt = " << o_cnt << "\n"
              "                 argc = " << argc << "\n"
              "                 fwai = " << fwai << "\n"
              "                nwacl = " << nwacl << "\n"
              "             help_opt = " << report(hlp) << "\n"
              "        help_help_opt = " << report(hhp) << "\n"
              "   help_help_help_opt = " << report(hhh) << "\n"
              "             test_opt = " << report(tst) << "\n"
	      "\n";
      exit(1);
   }
   if (help_opt == on) {
      wrt_help(pgm_nm);
      exit(1);
   }
   if (help_help_opt == on) {
      wrt_more_help(pgm_nm);
      exit(1);
   }
   if (help_help_help_opt == on) {
      wrt_much_more_help(pgm_nm);
      exit(1);
   }
   if (nwacl > 1)
      error_exit_too_many_cmnd_line_args();
}
