#include "grade.h"

// ---
// Offer instructions to the user who has selected the option
//
//    compute total scores
//
// This function is invoked in compute_total_scores().
//

void prn_c_t_s_info(void)
{
   printf("%s\n%s\n\n%s\n%s\n%s\n\n%s\n%s\n%s\n%s\n\n",
      "Option 1:",
      "   All but the lowest k scores are totaled.",
      "Option 2:",
      "   First the scores are weighted.",
      "   Then all but the lowest k weighted scores are totaled.",
      "Option 3:",
      "   First the scores are put in descending order.",
      "   Then the scores are weighted.",
      "   Finally, all but the lowest k weighted scores are totaled.");
}

void prn_enter_info(void)
{
   printf("%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s",
      "A database might contain lines such as\n",
      "   ACEVEDO,ALEJANDRO\n",
      "            quiz:  9 7 10 5\n",
      "      quiz total:  31\n",
      "      project - simplex method in c\n",
      "   ALBRECHT,FREDERICK ED\n",
      "            quiz:  3 9 7 7\n",
      "      quiz total:  26\n",
      "      project - simplex method in pascal\n",
      "   ...\n",
      "After each name line a new info line can be added.\n",
      "For example, score lines such as the following can be added.\n",
      "   homework:  12 17 19 20 16 19 19\n",
      "In this example  \"homework:\"  is a tag.\n",
      "Nonscore lines are info lines that do not contain a colon.\n",
      "They can be added, too.\n\n");
}

// ---
// Print the go lines in the linked list of info lines
// pointed to by head.
//

void prn_ll_go_lines(int go[], int nn, INFO_LINE* head)
{
   int          i;
   int          n;
   INFO_LINE*   p;

   n = cnt_ll_lines(head);
   assert(n + 1 == nn);
   for (i = 1, p = head; p != NULL; ++i, p = p -> next)
      if (go[i])
	 printf("%s", p -> line);
   printf("\n\n");
}

// ---
// Print a linked list of lines.
//

void prn_ll_lines(LINE* head_ptr)
{
   int     i;
   LINE*   p;

   for (i = 1, p = head_ptr; p != NULL; ++i, p = p -> next)
      printf("%3d  %s", i, p -> line);
   printf("\n");
}

static void   prn_read_me_file();

void prn_main_info()
{
   cchr*   pgm_name = o.local_pgm_name();
   char    c;

   printf("%s\n%s\n\n%s\n%s\n%s\n\n%s\n%s\n%s\n%s%s%s\n\n%s",
      "To get started, you need to create a file with a list of names.",
      "For example, your list of names might look like",
      "   ANTHONY, RICK",
      "   APPLEMAN, ERIC",
      "   .....",
      "Write each name in uppercase letters.",
      "Put last name first, followed by a comma.",
      "Write each name on a separate line, beginning in column 1.",
      "This file will be the database for the ", pgm_name, " program.",
      "Do you want more detailed information?  ");
   c = reply();
   putchar('\n');
   if (c == 'y') {
#if 0
      base = ggetenv("BASE");
      sprintf(command,
	 "chmod a=r %s/%s; vi %s/%s; chmod u=rw,go= %s/%s",
	 base, READ_ME, base, READ_ME, base, READ_ME);
      gsystem(command);
#endif
      /*
      //  ---
      //  14 Dec 92
      //
      //  Peter Scott may want to use this program.
      //  If so, he will need be able to get the information
      //  contained in the READ_ME file.  Well, this is best
      //  accomplished by using the printf utility to
      //  encapsulate it.  The next function call
      //  contains the encapsulation.
      */
      prn_read_me_file();
      putchar('\n');
   }
}

static void prn_read_me_file()
{
   printf("%s\n",
      "Thursday   16:03:56 PST   14 February 1985\n"
      "\n"
      "grade:  DESIGN CONSIDERATIONS\n"
      "=============================\n"
      "\n"
      "Various kinds of lines must be distinguishable.\n"
      "\n"
      "   Header lines:\n"
      "      Header lines occur before the first name line.  After the\n"
      "      first name line only name lines and score lines can occur.\n"
      "      The header lines must be processed first.  The is...\n"
      "      functions can distingish between a name line, a score line,\n"
      "      a total line, and a simple score line.\n"
      "\n"
      "   Name lines:\n"
      "      A name line begins with a capital letter and contains\n"
      "      punctuation.  Only letters can occur before the first\n"
      "      punctuation.  See isname.c for details.  The definition\n"
      "      changes when the administration changes its procedures.\n"
      "\n"
      "   Score lines:\n"
      "      A score line begins with one or more blanks or tabs.\n"
      "      It contains a colon which ends the tag.  Following the colon\n"
      "      is one or more scores.  A comment can occur at the end of\n"
      "      a score line.\n"
      "\n"
      "      Comment:\n"
      "         A comment is surrounded by  //  and  newline\n"
      "         or by  /*  and  newline or by  #  and newline.\n"
      "         A comment can occur at the end of a score line.\n"
      "\n"
      "   Total lines:\n"
      "      A total line is a score line with one of the strings\n"
      "         \"total\"   \"Total\"   \"TOTAL\"\n"
      "      as a substring of its tag.\n"
      "\n"
      "   Simple score lines:\n"
      "      A simple score line is a score line which is not a total line.\n"
      "\n"
      "   Nonscore lines:\n"
      "      None of the above.  For example\n"
      "         grade for the course  a+\n"
      "      Note, however, that a better strategy is put such information\n"
      "      into a score line as follows:\n"
      "         grade:  A+\n"
      "      Now this line can be pretty printed along with other score lines.\n"
      "      It is not required to have just numerical scores.\n"
      "\n"
      "   Info lines:\n"
      "      All lines other than header lines and name lines.\n"
      "      Thus info lines are comprised of score lines and nonscore lines.\n"
      "\n"
      "NOTES\n"
      "=====\n"
      "\n"
      "   1   Header lines have to be treated first.\n"
      "       After that, isname(), isscore(), issimple_score(),\n"
      "       istotal_score(), isnonscore() will test for the\n"
      "       line type.\n"
      "\n"
      "   2   cll ... := create linked list ...\n"
      "       These are key functions.\n"
      "\n"
      "   3   The following function creates space dynamically, but no attempt\n"
      "       is made to ever free the small amount of space that is created.\n"
      "       The space is often abandoned without freeing it.\n"
      "          blank_spaces()\n"
      "       I may redo this.  It seems like a bad design principle.\n"
      "\n"
      "   4   The program makes a back up in database_bkup.\n"
      "       Before, I let backups accumulate, but it cluttered up\n"
      "       the directory too much.  Hopefully, the grade program\n"
      "       is robust.\n"
      "\n"
      "   5   If the program is run and a cntrl-c is used to kill it,\n"
      "       then a tmp_XXXXXX file is left in the directory.\n"
      "       Unless a lot of processing has been done, this file will\n"
      "       have nothing in it.  After a while these files clutter\n"
      "       up the directory.  I need to find out how to intercept\n"
      "       the cntrl-c signal.\n"
      "\n"
      "At the moment compute_statistics() is a top level option.\n"
      "This may not be the best design.\n"
      "Think about it.\n"
      "\n"
      "\n"
      ":::::::::::::::::::::::::::::::::::::::::::::::\n"
      "Wednesday   10:05:15 PST   25 February 1987\n"
      "\n"
      "All the functions that have to do with letter grades\n"
      "and the writing of evaluations are to be made available\n"
      "via the function assign_grades().  Old code, some of it\n"
      "never completed is to be put into the directory\n"
      "\n"
      "   save\n"
      "\n"
      "The following functions will be kept there until\n"
      "everything settles down:\n"
      "\n"
      "   assign_final_grades()\n"
      "   change_scores_to_words()\n"
      "   enter_lines()\n"
      "   translate_letter_grades()\n"
      "\n"
      "::::::::::::::::::::::::::::::::::::::::::::::::\n"
      "Sunday   12:33:21 PDT   1 May 1988\n"
      "\n"
      "The code is being redesigned so that the ditroff and nroff\n"
      "header lines are taken from the top of the file <database>_header.\n"
      "If, for example, the database name is class, then the header lines\n"
      "are taken from the file\n"
      "\n"
      "   class_header\n"
      "\n");
}

// ---
// Suppose that the name of the database is class.
// Then statistics are printed in the file class_statistics.
//
// nsl             := number of score lines
// go[i]           := number of scores on (i + 1)st score line
// cnt_array[i][j] := count of scores corresponding to the
//                       (i + 1)st score line, (j + 1)st position
// avg_array[i][j] := avg of scores corresponding to the
//                       (i + 1)st score line, (j + 1)st position
//

void prn_statistics(cchr* database, SCORE_LINE* head,
		    int** cnt_array, dbl** avg_array, int* go, int nsl)
{
   char          out_file_name[maxword];
   char*         q;
   int           i;
   int           j;
   int           field_length_1;
   int           field_length_2;
   FILE*         ofp;
   SCORE_LINE*   p = head;

   strcpy(out_file_name, database);
   strcat(out_file_name, "_statistics");
   ofp = gfopen(out_file_name, "w");
   field_length_1 = 7;
   field_length_2 = 5;
   fprintf(ofp, "%s%s\n%s\n\n",
      "STATISTICS for ", database,
      "::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::");
   fprintf(ofp, "%s\n%s\n",
      "COUNTS",
      "------");
   for (i = 0, p = head; i < nsl && p != NULL; ++i,  p = p -> next) {
      q = strchr(p -> line, ':') + 1;
      *q = '\0';                           /* truncate line to get tag */
      fprintf(ofp, "%s", p -> line);
      for (j = 0; j < go[i]; ++j)
	 if (j == 0)
	    fprintf(ofp, "%*d", field_length_1, cnt_array[i][j]);
	 else
	    fprintf(ofp, "%*d", field_length_2, cnt_array[i][j]);
      fprintf(ofp,"\n");
   }
   fprintf(ofp, "\n%s\n%s\n",
      "AVERAGES",
      "--------");
   for (i = 0, p = head; i < nsl && p != NULL; ++i,  p = p -> next) {
      fprintf(ofp, "%s", p -> line);
      for (j = 0; j < go[i]; ++j)
	 if (j == 0)
	    fprintf(ofp, "%*.1f", field_length_1, avg_array[i][j]);
	 else
	    fprintf(ofp, "%*.1f", field_length_2, avg_array[i][j]);
      fprintf(ofp,"\n");
   }
   gfclose(ofp);
   for (i = 0; i < nsl; ++i) {
      free(cnt_array[i]);
      free ((char *) avg_array[i]);
   }
   free(cnt_array);
   free(avg_array);
   free(go);
}
