/*
// ---
// 21 Nov 94
//
// Things have changed.  Here is a new database example:
//
//    Date: Mon, 21 Nov 1994 09:28:41 -0800
//    To: blufox@cats.ucsc.edu
//    From: script@cats.ucsc.edu (SCRIPT Center, x4682)
//
//    ^^^^,Do not remove or modify these lines. Enter evaluation text between them.
//    @@@@,MATH   012    01 ,55480,942,KELLEY,A.         
//    &&&&,AGCONGAY, ARLENE JO A, ,560590741,F,CW,SO,CMP1,    ,PL,55480,942
//    b
//    &&&&,ALLEN, JONATHAN EDWAR, ,569892903,M,OA,JR,CMP ,    ,PL,55480,942
//    f
//    &&&&,AMPON, RODERICK D    , ,559938474,M,MR,JR,CMP ,    ,PL,55480,942
//    c
//    &&&&,ARREDONDO, GUSTAVO   , ,617565846,M,CL,SO,PHY1,    ,LG,55480,942
//    f
//    &&&&,ARTETA, CARLOS OSCAR , ,621564796,M,MR,JR,ECON,    ,LG,55480,942
//    a++
//    .....
*/

/*
//   Database example:
//   -----------------
//      Sched. #: 1375 Course: LINEAR ALGEBRA              Instr.: KELLEY,A.
//      Enrolled: Tue Jun 12 15:01:14 1984                At Pool: 05
//      Machine: c      Account: blufox
//      NAME: EDELSON, DANIEL ROSS   ID: 566556382  F86-COURSE: 40900  ...
//      a+
//      NAME: GAVER, HARRY LAWRENCE  ID: 175369005  F86-COURSE: 40900  ...
//      a
//      NAME: GREEN, DANIEL RUSSELL  ID: 564041798  F86-COURSE: 40900  ...
//      b
//      . . . . .
//   
//   Database requirement:
//   ---------------------
//      After each name line only one info line consisting of only one word.
//
//   Corresponding files needed:
//   ---------------------------
//      grade_a+     grade_a     grade_b     ...
//   
*/

#include "grade.h"

#define   OFFSET   3                    /* for formatting the printout */

struct grade {                                 /* store a letter grade */
   char           *g;
   struct grade   *next;
};

typedef   struct grade   grade;

static void   chk_trans_for_err(FILE* ifp);
static void   prn_trans_info(void);
static void   recursive_release(grade* p);

void translate_letter_grades(cchr* database, int test_mode)
{
   char**   a;                               /* array of letter grades */
   char**   filename;                            /* array of filenames */
   char     tfn[maxstring];                           /* temp filename */
   char*    tmp;
   char     cmnd[maxstring];
   char     g_line[maxline];
   char     line[maxline];
   char     tlgfn[maxword];        /* translate letter grades filename */
   char     tmp_grade[maxword];
   int      c;
   int      cnt = 0;
   int      i;
   int      j;
   int      n;
   int      nn;
   FILE**   afp;                             /* array of file pointers */
   FILE*    ifp;
   FILE*    ofp;
   grade*   hp = NULL;
   grade*   p;
   grade*   q;

   printf("Do you want information?  ");
   c = reply();
   putchar('\n');
   if (c == 'y') {
      prn_trans_info();
      printf("Do you want to continue?  ");
      c = reply();
      putchar('\n');
      if (c == 'n')
         return;                                   /* function aborted */
   }
   /*
   // Open the database for reading,
   // and open a tmp file for writing.
   */
   tmpnam(tfn);
   ifp = gfopen(database, "r");
   ofp = gfopen(tfn, "w");
   chk_trans_for_err(ifp);
   rewind(ifp);
   while (fgets(line, maxline, ifp) != NULL && !isname(line))
      ;                                           /* skip header lines */
   while (fgets(line, maxline, ifp) != NULL) {
      if (!isname(line)) {                                /* info line */
         sscanf(line, "%s", tmp_grade);
         for (p = hp; p != NULL; p = p -> next)     /* null terminated */
            if (strcmp(p -> g, tmp_grade) == 0)
               break;
         if (p == NULL) {                         /* found a new grade */
            if (hp == NULL)
               hp = q = (grade *) gmalloc(sizeof(grade));
            else
               q = q -> next = (grade *) gmalloc(sizeof(grade));
            q -> g = (char *) gcalloc(strlen(tmp_grade) + 1, sizeof(char));
            strcpy(q -> g, tmp_grade);
            q -> next = NULL;             /* null termination required */
            ++cnt;
         }
      }
   }
   if (cnt == 0) {
      printf("ERROR: No grades in the database - bye!\n\n");
      exit(1);
   }
   n = cnt;
   a = (char **) gcalloc(n, sizeof(char *));
   for (i = 0, p = hp; i < n; ++i, p = p -> next)
      a[i] = p -> g;
   for (i = 0; i < n - 1; ++i)                /* lexicographical order */
      for (j = i + 1; j < n; ++j)
         if (strcmp(a[i], a[j]) > 0) {
            tmp = a[i];
            a[i] = a[j];
            a[j] = tmp;
         }
   /*
   //   We now have an array of grades, for example,
   //
   //      a   a+   b   c+   c   ...
   //
   //   Next we want to create a corresponding array of filenames,
   //
   //      grade_a   grade_a+   grade_b   ...
   //
   */
   filename = (char **) gcalloc(n, sizeof(char *));
   for (i = 0; i < n; ++i) {
      nn = strlen("grade_") + strlen(a[i]) + 1;
      filename[i] = (char *) gcalloc(nn, sizeof(char));
      strcpy(filename[i], "grade_");
      strcat(filename[i], a[i]);
   }
   printf("%*s%-12s%s\n%*s%-12s%s\n",
      OFFSET, "", "Grades", "Corresponding Files",
      OFFSET, "", "------", "-------------------");
   for (i = 0; i < n; ++i)
      printf("%*s%-12s%s\n",
         OFFSET, "", a[i], filename[i]);
   printf("\nIs this correct?  ");
   c = reply();
   putchar('\n');
   if (c == 'n') {
      printf("Program aborted - good bye!\n\n");
      exit(1);                                                 /* exit */
   }
   afp = (FILE **) gcalloc(n, sizeof(FILE *));
   for (i = 0; i < n; ++i)
      afp[i] = gfopen(filename[i], "r");
   /*
   // An array of files has been opened.
   // Now we are ready to translate the letter grades.
   */
   rewind(ifp);
   while (fgets(line, maxline, ifp) != NULL && !isname(line))
      fputs(line, ofp);                                 /* header line */
   do {
      fputs(line, ofp);                                   /* name line */
      fgets(line, maxline, ifp);                          /* info line */
      sscanf(line, "%s", tmp_grade);
      for (i = 0; i < n; ++i)
         if (strcmp(a[i], tmp_grade) == 0)
            break;                             /* found a letter grade */
      rewind(afp[i]);
      while (fgets(g_line, maxline, afp[i]) != NULL)/* translation phase */
         fputs(g_line, ofp);
   } while (fgets(line, maxline, ifp) != NULL);           /* name line */
   /*
   // The translation of letter grades to words is finished.
   // Close the files and free all the work space.
   */
   gfclose(ifp);
   gfclose(ofp);
   for (i = 0; i < n; ++i)
      gfclose(afp[i]);
   free(afp);
   for (i = 0; i < n - 1; ++i)
      free(filename[i]);
   free(filename);
   recursive_release(hp);
   free(a);
   /*
   // Finally, do the last bit of housekeeping.
   */
   if (test_mode) {
      printf("%s\n%s",
         "TEST MODE: The original database will not be changed.",
         "           Do you wish to vi the temp file?  ");
      c = reply();
      putchar('\n');
      if (c == 'y' || c == '\n') {
         sprintf(cmnd, "vi %s", tfn);
         gsystem(cmnd);
      }
      gremove(tfn);
      printf("\nThe file %s has been removed.\n\n", tfn);
   }
   else {
      sprintf(tlgfn, "%s%s", database, "_tlg");
      if (access(tlgfn, F_OK) == 0) {
         printf("Overwrite the file %s?  ", tlgfn);
         c = reply();
         putchar('\n');
         if (c == 'y' || c == '\n') {
	    copy(tfn, tlgfn);
	    gremove(tfn);
            printf("%s\n%s%s%s\n\n",
               "Translation of letter grades is complete.",
               "Look for the results in the file ", tlgfn, ".");
         }
         else {
            gremove(tfn);
            printf("The file %s was not overwritten.\n", tlgfn);
            printf("No translation of letter grades occurred!\n\n");
         }
      }
      else {
	 copy(tfn, tlgfn);
	 gremove(tfn);
         printf("%s\n%s%s%s\n\n",
            "Translation of letter grades is complete.",
            "Look for the results in the file ", tlgfn, ".");
      }
   }
}

static void prn_trans_info(void)
{
   char    cmnd[maxstring];
   char    tfn[maxstring];
   FILE*   ofp;

   tmpnam(tfn);
   ofp = gfopen(tfn, "w");
   fprintf(ofp, "%s",
      "INSTRUCTIONS:\n"
      "\n"
      "Here is how the scheme to translate letter grades works.\n"
      "Suppose your database looks like\n"
      "\n"
      "---\n"
      "Date: Mon, 21 Nov 1994 09:28:41 -0800\n"
      "To: blufox@cats.ucsc.edu\n"
      "From: script@cats.ucsc.edu (SCRIPT Center, x4682)\n"
      "\n"
      "^^^^,Do not remove or modify these lines. Enter evaluation text between them.\n"
      "@@@@,MATH   012    01 ,55480,942,KELLEY,A.         \n"
      "&&&&,AGCONGAY, ARLENE JO A, ,560590741,F,CW,SO,CMP1,    ,PL,55480,942\n"
      "b\n"
      "&&&&,ALLEN, JONATHAN EDWAR, ,569892903,M,OA,JR,CMP ,    ,PL,55480,942\n"
      "f\n"
      "&&&&,AMPON, RODERICK D    , ,559938474,M,MR,JR,CMP ,    ,PL,55480,942\n"
      "c\n"
      "&&&&,ARREDONDO, GUSTAVO   , ,617565846,M,CL,SO,PHY1,    ,LG,55480,942\n"
      "f\n"
      "&&&&,ARTETA, CARLOS OSCAR , ,621564796,M,MR,JR,ECON,    ,LG,55480,942\n"
      "a++\n"
      ".....\n"
      "---\n"
      "\n"
      "Each grade that immediately follows a name line will be replaced\n"
      "by the contents of a corresponding grade file.  More explicitly,\n"
      "if you use grades such as\n"
      "\n"
      "   a+     a     b+     b     ...\n"
      "\n"
      "you will be required to have the corresponding files\n"
      "\n"
      "   grade_a+     grade_a     grade_b+     grade_b     ...\n"
      "\n");
   gfclose(ofp);
   sprintf(cmnd, "more %s", tfn);
   gsystem(cmnd);
   gremove(tfn);
}

static void chk_trans_for_err(FILE* ifp)
{
   char   line[maxline];

   while (fgets(line, maxline, ifp) != NULL && !isname(line))
      ;                                           /* skip header lines */
   while (fgets(line, maxline, ifp) != NULL) {  /* should be info line */
      if (isname(line)) {
         printf("%s\n%s\n\n%s\n\n%s\n",
            "ERROR: Following each name line there must be only",
            "       one info line containing only one word.",
            "The following line is a name line:",
            line);
         exit(1);
      }
      if (word_cnt(line) != 1) {
         printf("%s\n%s\n\n%s\n\n%s\n",
            "ERROR: Following each name line there must be only",
            "       one info line containing only one word.",
            "The following line does not contain one word:",
            line);
         exit(1);
      }
      if (fgets(line, maxline, ifp) != NULL) {  /* should be name line */
         if (!isname(line)) {
            printf("%s",
               "ERROR:\n"
               "\n"
               "   The database does not have the right format.\n"
               "   After each name line there must be only one\n"
               "   info line containing only one word.\n"
               "\n"
               "   Bye!\n"
               "\n");
            exit(1);
         }
      }
   }
}

static void recursive_release(grade* p)
{
   if (p -> next == NULL) {
      free(p -> g);
      free(p);
   }
   else (recursive_release(p -> next));
}
